﻿using System;
using System.Collections.Generic;
using Syncfusion.SfSchedule.XForms;
using Xamarin.Forms;

namespace Sample
{
    public partial class ScheduleViewModel : ContentPage
    {
        public ScheduleAppointmentCollection Appointments { get; set; }
        List<string> teamManagement;
        List<Color> color_collection;
        List<DateTime> start_time_collection;
        List<DateTime> end_time_collection;

        public ScheduleViewModel()
        {
            Appointments = new ScheduleAppointmentCollection();
            CreateRandomNumbersCollection();
            CreateStartTimeCollection();
            CreateEndTimeCollection();
            CreateSubjectCollection();
            CreateColorCollection();
            IntializeAppoitments(10);
        }

        private void IntializeAppoitments(int count)
        {
            for (int i = 0; i < count; i++)
            {
                ScheduleAppointment scheduleAppointment = new ScheduleAppointment();
                scheduleAppointment.Color = color_collection[i];
                scheduleAppointment.Subject = teamManagement[i];
                scheduleAppointment.StartTime = start_time_collection[i];
                scheduleAppointment.EndTime = end_time_collection[i];
                Appointments.Add(scheduleAppointment);
            }
        }

        private void CreateSubjectCollection()
        {
            teamManagement = new List<string>();
            teamManagement.Add("General Meeting");
            teamManagement.Add("Plan Execution");
            teamManagement.Add("Project Plan");
            teamManagement.Add("Consulting");
            teamManagement.Add("Performance Check");
            teamManagement.Add("General Meeting");
            teamManagement.Add("Plan Execution");
            teamManagement.Add("Project Plan");
            teamManagement.Add("Consulting");
            teamManagement.Add("Performance Check");

        }

        //creating color collection
        private void CreateColorCollection()
        {
            color_collection = new List<Color>();
            color_collection.Add(Color.FromHex("#FFA2C139"));
            color_collection.Add(Color.FromHex("#FFD80073"));
            color_collection.Add(Color.FromHex("#FF1BA1E2"));
            color_collection.Add(Color.FromHex("#FFE671B8"));
            color_collection.Add(Color.FromHex("#FFF09609"));
            color_collection.Add(Color.FromHex("#FF339933"));
            color_collection.Add(Color.FromHex("#FF00ABA9"));
            color_collection.Add(Color.FromHex("#FFE671B8"));
            color_collection.Add(Color.FromHex("#FF1BA1E2"));
            color_collection.Add(Color.FromHex("#FFD80073"));
            color_collection.Add(Color.FromHex("#FFA2C139"));
            color_collection.Add(Color.FromHex("#FFA2C139"));
            color_collection.Add(Color.FromHex("#FFD80073"));
            color_collection.Add(Color.FromHex("#FF339933"));
            color_collection.Add(Color.FromHex("#FFE671B8"));
            color_collection.Add(Color.FromHex("#FF00ABA9"));
        }

        //creating random number collection
        List<int> randomNums = new List<int>();
        private void CreateRandomNumbersCollection()
        {
            randomNums = new List<int>();

            Random rand = new Random();

            for (int i = 0; i < 10; i++)
            {
                int random = rand.Next(9, 15);
                randomNums.Add(random);
            }
        }

        // creating StartTime collection
        private void CreateStartTimeCollection()
        {
            start_time_collection = new List<DateTime>();
            DateTime currentDate = DateTime.Now;

            int count = 0;
            for (int i = -5; i < 5; i++)
            {
                DateTime startTime = new DateTime(currentDate.Year, currentDate.Month, currentDate.Day, randomNums[count], 0, 0);
                DateTime startDateTime = startTime.AddDays(i);
                start_time_collection.Add(startDateTime);
                count++;
            }
        }

        //  creating EndTime collection
        private void CreateEndTimeCollection()
        {
            end_time_collection = new List<DateTime>();
            DateTime currentDate = DateTime.Now;
            int count = 0;
            for (int i = -5; i < 5; i++)
            {
                DateTime endTime = new DateTime(currentDate.Year, currentDate.Month, currentDate.Day, randomNums[count] + 1, 0, 0);
                DateTime endDateTime = endTime.AddDays(i);
                end_time_collection.Add(endDateTime);
                count++;
            }
        }
    }
}

